// This file has been generated, if you wish to
// modify it in a permanent way, please refer
// to the script file : gen/generator_java.rb

import java.util.ArrayList;
import java.util.Arrays;

public class Prologin extends Interface {

    private static final int NB_DEP = 8;
    private static final int[][] DEP = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}, {1, 1}, {-1, -1}, {1, -1}, {-1, 1}};

    // Infos carte
    private static Case[] lib, adv, all;
    private static ArrayList<Case> tmpLib, tmpAdv, tmpAll;

    // Compteur de tours pour les maisons
    private static ArrayList<Case> toursAll;

    private static boolean firstHouse;

    // Ou placer le monument achete
    private static Case mon;

    // Module Piksou
    private static Piksou piksou;


    // Fonction appelee au debut de la partie
    public void init_game() {
        firstHouse = true;
        toursAll = new ArrayList<Case>();
        piksou = new Piksou();
    }


    // Fonction appelee a la fin de la partie
    public void end_game() {
    }


    // Fonction appelee a chaque phase de jeu
    public void jouer() {
        checkMap();

        if(finances(0) >= 15 && firstHouse && !piksou.active) {
            if(piksou.zoneur()) {
                // Construction du pont
                if(type_case(piksou.pont.x, piksou.pont.y) == VIDE)
                    construire_route(piksou.pont.x, piksou.pont.y);
                // Reservation de l'emplacement du monument
                reserver_case(piksou.bat.x, piksou.bat.y);
                // Construction des deux premieres maisons
                construire_maison(piksou.maisons[0].x, piksou.maisons[0].y);
                construire_maison(piksou.maisons[1].x, piksou.maisons[1].y);
                // Reservation des deux autres
                reserver_case(piksou.maisons[2].x, piksou.maisons[2].y);
                reserver_case(piksou.maisons[3].x, piksou.maisons[3].y);
                return;
            }
        }
        if(piksou.active) {
            boolean fini = false;
            if(type_case(piksou.maisons[2].x, piksou.maisons[2].y) == RESERVATION) {
                construire_maison(piksou.maisons[2].x, piksou.maisons[2].y);
                fini = true;
            }
            if(type_case(piksou.maisons[3].x, piksou.maisons[3].y) == RESERVATION) {
                construire_maison(piksou.maisons[3].x, piksou.maisons[3].y);
                fini = true;
            }
            piksou.ok();
            if(fini)
                return;
        }

        ArrayList<Case> meilR = new ArrayList<Case>();
        ArrayList<Case> meilM = new ArrayList<Case>();
        boolean prems = true;

        if(lib[0].val >= 2) {
            meilM.add(new Case(lib[0].x, lib[0].y, lib[0].val));
            prems = false;
        }

        for(int a=0 ; a<lib.length ; a++) {
            if(route_possible(lib[a].x, lib[a].y) != SUCCES)
                continue;
            for(int b=0 ; b<NB_DEP ; b++) {
                int x = lib[a].x+DEP[b][0];
                int y = lib[a].y+DEP[b][1];
                int val;
                if(type_case(x, y) == VIDE && (val=valeur_case(x, y)) >= 2) {
                    if(prems) {
                        meilR.add(new Case(lib[a].x, lib[a].y, lib[a].val));
                        meilM.add(new Case(x, y, val));
                        prems = false;
                    }
                    else if(val > meilM.get(0).val) {
                        meilR.clear();
                        meilM.clear();
                        meilR.add(new Case(lib[a].x, lib[a].y, lib[a].val));
                        meilM.add(new Case(x, y, val));
                    }
                    else if(val == meilM.get(0).val) {
                        meilR.add(new Case(lib[a].x, lib[a].y, lib[a].val));
                        meilM.add(new Case(x, y, val));
                    }
                }
            }
        }

        int mSize = meilM.size();
        if(mSize > 0)
            if(meilM.get(0).val >= 2) {
                if(meilR.size() > 0)
                    if(meilR.get(0).x != -1)
                        construire_route(meilR.get(0).x, meilR.get(0).y);
                int a=0;
                for(a=0 ; a<mSize ; a++)
                    if(construire_maison(meilM.get(a).x, meilM.get(a).y) == SUCCES)
                        break;
                System.out.println("x : "+meilM.get(a).x+" | y : "+meilM.get(a).y+" | val : "+meilM.get(a).val+" ");
                if(meilM.get(a).val >= 4) {
                    System.out.println("Maison vendue pour sa valeur : ("+meilM.get(a).x+", "+meilM.get(a).y+")");
                    vendre_maison(meilM.get(a).x, meilM.get(a).y);
                }
                else
                    toursAll.add(new Case(meilM.get(a).x, meilM.get(a).y, 0));
            }

        //Achat de la 2nde maison
        int cout = cout_achat_maison();
        if(cout == 0) {
            for(int a=0 ; a<lib.length ; a++)
                if(construire_maison(lib[a].x, lib[a].y) == SUCCES) {
                    toursAll.add(new Case(lib[a].x, lib[a].y, 0));
                    break;
                }
        }
        if(cout == 1 && finances(0) > ARGENT_INITIAL && firstHouse) {
            firstHouse = false;
            jouer();
        }
    }


    // Fonction appelee a chaque phase d'enchere
    public void enchere() { 
        firstHouse = true;
        
        majToursAll();
        checkMap();
        int monum = monument_en_cours();
        int val = prestige_monument(monum);
        int portee = portee_monument(monum);

        if(finances(0) < 10 || val < 1)
            return;

        if(piksou.active && val > 1) {
            mon = piksou.bat;
            int montant = val*4 -3;
            if(montant > 7)
                montant = 7;
            encherir(montant);
            return;
        }

        Case meil = new Case(0, 0, -1);

        for(int a=0 ; a<lib.length ; a++) {
            int temp = calcGain(lib[a].x, lib[a].y, val, portee);
            if(temp > meil.val)
                meil = new Case(lib[a].x, lib[a].y, temp);
        }
        mon = meil;

        if(finances(0) > mon.val)
            encherir(mon.val-2);
    }


    // Fonction appelee a chaque phase de placesment de monument
    public void placement() {
        construire_monument(mon.x, mon.y);

        if(mon.equals(piksou.bat)) {
            piksou.ok();
            piksou.vend();
        }
    }


    // Fais l'inventaire des cases du plateau
    public void checkMap() {
        boolean[][] visit = new boolean[TAILLE_CARTE][TAILLE_CARTE];
        for(int a=0 ; a<TAILLE_CARTE ; a++)
            for(int b=0 ; b<TAILLE_CARTE ; b++)
                visit[a][b] = false;

        tmpLib = new ArrayList<Case>();
        tmpAll = new ArrayList<Case>();
        tmpAdv = new ArrayList<Case>();

        checkMap(TAILLE_CARTE / 2, TAILLE_CARTE / 2, visit);

        lib = new Case[tmpLib.size()];
        all = new Case[tmpAll.size()];
        adv = new Case[tmpAdv.size()];

        for(int a=0 ; a<lib.length ; a++)
            lib[a] = tmpLib.get(a);
        for(int a=0 ; a<all.length ; a++)
            all[a] = tmpAll.get(a);
        for(int a=0 ; a<adv.length ; a++)
            adv[a] = tmpAdv.get(a);

        Arrays.sort(lib);
        Arrays.sort(all);
        Arrays.sort(adv);
    }
    public void checkMap(int x, int y, boolean[][] visit) {
        if(x < 0 || x > TAILLE_CARTE-1 || y < 0 || y > TAILLE_CARTE-1)
            return;

        if(visit[x][y])
            return;
        visit[x][y] = true;

        int type = type_case(x, y);
        if(type == VIDE) {
            tmpLib.add(new Case(x, y, valeur_case(x, y)));
            return;
        }
        else if(type == MAISON)
            if(appartenance(x, y) == 0) {
                tmpAll.add(new Case(x, y, valeur_case(x, y)));
                return;
            }
            else {
                tmpAdv.add(new Case(x, y, valeur_case(x, y)));
                return;
            }

        if(type != ROUTE)
            return;

        int newX, newY;
        for(int a=0 ; a<NB_DEP ; a++) {
            newX = x+DEP[a][0];
            newY = y+DEP[a][1];
            checkMap(newX, newY, visit);
        }
    }


    // Calcule les gains obtenus par un ;onu;ent a une position
    // Cette valeur est celle gagnee par les maisons alliees moins celle gagnee par les maisons adverses
    private int calcGain(int x, int y, int val, int portee) {
        int gauche = x-portee, haut = y-portee;
        int ret = 0;
        for(int a=gauche ; a<gauche+1+portee*2 ; a++)
            for(int b=haut ; b<haut+1+portee*2 ; b++)
                if(type_case(a, b) == MAISON) {
                    if(appartenance(a, b) == 0)
                        ret += val;
                    else
                        ret -= val;
                }
        return ret;
    }


    private void majToursAll() {
        int size = toursAll.size();
        for(int a=0 ; a<size ; a++) {
            toursAll.get(a).val++;
            if(toursAll.get(a).val >= 4) {
                System.out.println("Maison vendue apres 4 tours : ("+toursAll.get(a).x+", "+toursAll.get(a).y+")");
                vendre_maison(toursAll.get(a).x, toursAll.get(a).y);
                toursAll.remove(a--);
                size--;
            }
            else if(valeur_case(toursAll.get(a).x, toursAll.get(a).y) >= 4) {
                System.out.println("Maison vendue pour sa valeur : ("+toursAll.get(a).x+", "+toursAll.get(a).y+")");
                vendre_maison(toursAll.get(a).x, toursAll.get(a).y);
                toursAll.remove(a--);
                size--;
            }
        }
    }

}
class Case implements java.lang.Comparable<Case> {
    public int x, y, val;

    public Case(int x, int y, int val) {
        this.x = x;
        this.y = y;
        this.val = val;
    }

    public int compareTo(Case o) {
        if(this.val == o.val)
            return 0;
        if(this.val > o.val)
            return -1;
        return 1;
    }

    public String toString() {
        return "x : "+this.x+" | y : "+this.y+" | val : "+this.val;
    }

    public boolean equals(Case ca) {
        return (this.x == ca.x && this.y == ca.y);
    }
}
class Piksou extends Interface {
    private static final int NB_DEP = 4;
    private static final int[][] DEP = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};

    private static final int[][] ZONES = {
            {1, -1},
            {1, 0},
            {1, 1},
            {2, -1},
            {2, 0},
            {2, 1},
    };
    private static final boolean[] Z_INV = {true, true, false, false};
    private static final int[] Z_MUL = {1, -1, 1, -1};

    public boolean active;
    public int conf;
    public Case dep, pont, bat;
    public Case[] maisons;


    public Piksou() {
        this.active = false;
        this.conf = -1;
        this.dep = new Case(-1, -1, -1);
        this.pont = new Case(-1, -1, -1);
        this.bat = new Case(-1, -1, -1);
        this.maisons = new Case[4];
        this.fin = 0;
    }


    private int fin;
    public void ok() {
        this.fin++;
        if(this.fin == 2) {
            for(int a=0 ; a<4 ; a++) {
                vendre_maison(this.maisons[a].x, this.maisons[a].y);
                System.out.println("Operation Piksou - maison vendue : ("+this.maisons[a].x+", "+this.maisons[a].y+")");
            }

            this.active = false;
            this.conf = -1;
            this.dep = new Case(-1, -1, -1);
            this.pont = new Case(-1, -1, -1);
            this.bat = new Case(-1, -1, -1);
            this.maisons = new Case[4];
            this.fin = 0;
        }
    }


    public void vend() {
        for(int a=0 ; a<4 ; a++) {
            if(type_case(this.maisons[a].x, this.maisons[a].y) == MAISON)
                vendre_maison(this.maisons[a].x, this.maisons[a].y);
        }
    }


    public boolean zoneur() {
        System.out.println("Module Piksou - Zoneur");
        
        ArrayList<Case> routes = new ArrayList<Case>();
        boolean[][] visit = new boolean[TAILLE_CARTE][TAILLE_CARTE];
        for(int a=0 ; a<TAILLE_CARTE ; a++)
            for(int b=0 ; b<TAILLE_CARTE ; b++)
                visit[a][b] = false;
        checkRoutes(TAILLE_CARTE/2, TAILLE_CARTE/2, routes, visit);

        boolean brk = false, find = false;
        int size = routes.size();
        for(int r=0 ; r<size ; r++) {
            int dX = routes.get(r).x;
            int dY = routes.get(r).y;
            for(int z=0 ; z<4 ; z++) {
                brk = false;
                for(int a=0 ; a<6 ; a++) {
                    int x;
                    int y;
                    if(Z_INV[z]) {      // En colonnes
                        x = dX+ZONES[a][0]*Z_MUL[z];
                        y = dY+ZONES[a][1];
                    }
                    else {              // En lignes
                        x = dX+ZONES[a][1];
                        y = dY+ZONES[a][0]*Z_MUL[z];
                    }
                    int type = type_case(x, y);
                    // La case rend la config' mauvaise : on passe a z suivant
                    if(!(type == VIDE || (type == ROUTE && a==1)) || valeur_case(x, y) > 1) {
                        brk = true;
                        break;
                    }
                }
                // Aucune case n'a break : la config' est bonne
                if(!brk) {
                    find = true;
                    conf = z;
                    dep = routes.get(r);
                    if(Z_INV[z]) {      // En colonnes
                        pont = new Case(dX+ZONES[1][0]*Z_MUL[z], dY+ZONES[1][1], -1);
                        bat = new Case(dX+ZONES[4][0]*Z_MUL[z], dY+ZONES[4][1], -1);

                        maisons[0] = new Case(dX+ZONES[0][0]*Z_MUL[z], dY+ZONES[0][1], -1);
                        maisons[1] = new Case(dX+ZONES[2][0]*Z_MUL[z], dY+ZONES[2][1], -1);
                        maisons[2] = new Case(dX+ZONES[3][0]*Z_MUL[z], dY+ZONES[3][1], -1);
                        maisons[3] = new Case(dX+ZONES[5][0]*Z_MUL[z], dY+ZONES[5][1], -1);
                    }
                    else {              // En lignes
                        pont = new Case(dX+ZONES[1][1], dY+ZONES[1][0]*Z_MUL[z], -1);
                        bat = new Case(dX+ZONES[4][1], dY+ZONES[4][0]*Z_MUL[z], -1);

                        maisons[0] = new Case(dX+ZONES[0][1], dY+ZONES[0][0]*Z_MUL[z], -1);
                        maisons[1] = new Case(dX+ZONES[2][1], dY+ZONES[2][0]*Z_MUL[z], -1);
                        maisons[2] = new Case(dX+ZONES[3][1], dY+ZONES[3][0]*Z_MUL[z], -1);
                        maisons[3] = new Case(dX+ZONES[5][1], dY+ZONES[5][0]*Z_MUL[z], -1);
                    }
                    break;
                }
            }
            if(find)
                break;
        }

        if(!find) {
            System.out.println("Pas de configuration Piksienne");
            return false;
        }

        System.out.println("CONFIG TROUVEE - Passage en mode Piksou");
        this.active = true;
        return true;
    }

    private void checkRoutes(int x, int y, ArrayList<Case> routes, boolean[][] visit) {
        if(x < 0 || x > TAILLE_CARTE-1 || y < 0 || y > TAILLE_CARTE-1)
            return;
        if(visit[x][y])
            return;
        visit[x][y] = true;
        int type = type_case(x, y);
        if(type != ROUTE)
            return;

        routes.add(new Case(x, y, -1));

        for(int a=0 ; a<NB_DEP ; a++) {
            int newX = x+DEP[a][0];
            int newY = y+DEP[a][1];
            checkRoutes(newX, newY, routes, visit);
        }
    }
}
